package com.tashow.cloud.product.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tashow.cloud.productapi.api.product.dto.ProdPropDO;
import com.tashow.cloud.productapi.api.product.dto.ProdPropValueDO;
import com.tashow.cloud.product.mapper.ProdPropMapper;
import com.tashow.cloud.product.mapper.ProdPropValueMapper;
import com.tashow.cloud.product.service.ProdPropService;
import com.tashow.cloud.productapi.api.product.vo.prod.ProdSaveReqVO;
import com.tashow.cloud.productapi.api.product.vo.prodprop.ProdPropPageReqVO;
import com.tashow.cloud.productapi.api.product.vo.prodprop.ProdPropSaveReqVO;
import com.tashow.cloud.productapi.api.product.vo.sku.SkuPropVO;
import com.tashow.cloud.productapi.enums.BaseEnum;
import com.tashow.cloud.productapi.enums.ErrorCodeConstants;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import com.tashow.cloud.common.pojo.PageResult;
import com.tashow.cloud.common.pojo.PageParam;
import com.tashow.cloud.common.util.object.BeanUtils;


import static com.tashow.cloud.common.exception.util.ServiceExceptionUtil.exception;

/**
 * 商品属性 Service 实现类
 *
 * @author 芋道源码
 */
@Service
@Validated
public class ProdPropServiceImpl extends ServiceImpl<ProdPropMapper, ProdPropDO>  implements ProdPropService {

    @Resource
    private ProdPropMapper prodPropMapper;
    @Resource
    private ProdPropValueMapper prodPropValueMapper;

    @Override
    public Long createProdProp(ProdPropSaveReqVO createReqVO) {
        // 插入
        ProdPropDO prodProp = BeanUtils.toBean(createReqVO, ProdPropDO.class);
        prodPropMapper.insert(prodProp);
        // 返回
        return prodProp.getPropId();
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void saveProdPropAndValues(ProdSaveReqVO createReqVOInfo) {

        for (ProdPropSaveReqVO createReqVO : createReqVOInfo.getProdPropSaveReqVO()){
            ProdPropDO dbProdProp = prodPropMapper.getProdPropByPropNameAndShopId(createReqVO.getPropName(), createReqVO.getProdId(), createReqVO.getRule());
            if (dbProdProp != null) {
                throw new RuntimeException("已有相同名称规格");
            }
            ProdPropDO prodProp = BeanUtils.toBean(createReqVO, ProdPropDO.class);
            prodProp.setProdId(createReqVOInfo.getProdId());
            prodPropMapper.insert(prodProp);
            if (CollUtil.isEmpty(createReqVO.getProdPropValues())) {
                return;
            }
            for (ProdPropValueDO prodPropValueDO : createReqVO.getProdPropValues()){
                prodPropValueDO.setPropId(prodProp.getId());
                prodPropValueMapper.insert(prodPropValueDO);
            }
        }
    }

    @Override
    @Transactional
    public void updateProdPropAndValues(SkuPropVO skuPropVO) {
        for (ProdPropSaveReqVO createReqVO : skuPropVO.getProdPropSaveReqVO()){
            ProdPropDO dbProdProp = prodPropMapper.getProdPropByPropNameAndShopId(createReqVO.getPropName(), createReqVO.getProdId(), createReqVO.getRule());
            if (dbProdProp != null) {
                throw new RuntimeException("已有相同名称规格");
            }
            ProdPropDO prodProp = BeanUtils.toBean(createReqVO, ProdPropDO.class);
            if(Objects.equals(BaseEnum.YES_ONE.getKey(),createReqVO.getIsExist())){
                prodPropMapper.insert(prodProp);
            }else {
                prodPropMapper.updateById(prodProp);
            }
            if (CollUtil.isEmpty(createReqVO.getProdPropValues())) {
                return;
            }
            for (ProdPropValueDO prodPropValueDO : createReqVO.getProdPropValues()){
                if(Objects.equals(BaseEnum.YES_ONE.getKey(),prodPropValueDO.getIsExist())){
                    prodPropValueDO.setPropId(prodProp.getId());
                    prodPropValueMapper.insert(prodPropValueDO);
                }else {
                    prodPropValueMapper.updateById(prodPropValueDO);
                }
            }
        }
    }


    @Override
    public void updateProdProp(ProdPropSaveReqVO updateReqVO) {
        // 校验存在
        validateProdPropExists(updateReqVO.getPropId());
        // 更新
        ProdPropDO updateObj = BeanUtils.toBean(updateReqVO, ProdPropDO.class);
        prodPropMapper.updateById(updateObj);
    }

    @Override
    public void deleteProdProp(Long id) {
        // 校验存在
        validateProdPropExists(id);
        // 删除
        prodPropMapper.deleteById(id);
    }

    private void validateProdPropExists(Long id) {
        if (prodPropMapper.selectById(id) == null) {
            throw exception(ErrorCodeConstants.PROD_PROP_NOT_EXISTS);
        }
    }

    @Override
    public ProdPropDO getProdProp(Long id) {
        return prodPropMapper.selectById(id);
    }

    @Override
    public PageResult<ProdPropDO> getProdPropPage(ProdPropPageReqVO pageReqVO) {
        return null;
    }

}